#pragma semicolon 1

#include <amxmodx>
#include <reapi>

new const szWeaponName[][] = {
	"weapon_p228","weapon_glock18","weapon_scout","weapon_hegrenade","weapon_xm1014","weapon_c4",
	"weapon_mac10","weapon_aug","weapon_smokegrenade","weapon_elite","weapon_fiveseven","weapon_ump45",
	"weapon_sg550","weapon_galil","weapon_famas","weapon_usp","weapon_awp","weapon_mp5navy","weapon_m249",
	"weapon_m3","weapon_m4a1","weapon_tmp","weapon_g3sg1","weapon_flashbang","weapon_deagle","weapon_sg552",
	"weapon_ak47","weapon_knife","weapon_p90"
};
new WeaponList;

public plugin_init() {
	register_plugin("Weapon Hud", "1.0.1", "PurposeLess");

	RegisterHookChain(RG_CBasePlayer_AddPlayerItem, "@CBasePlayer_AddPlayerItem_Post", .post = true);

	WeaponList = get_user_msgid("WeaponList");
}

public plugin_precache() {
	for(new i = 0; i < sizeof(szWeaponName); i++) {
		precache_generic(fmt("sprites/weapon/%s.txt", szWeaponName[i]));
	}
	for(new i = 1; i < 7; i++) {
		precache_generic(fmt("sprites/weapon/hud%i.spr", i));
	}
}

public client_command(id) {
	new args[32];
	read_argv(0, args, charsmax(args));

	if(args[7] == 'w' && args[8] == 'e') {
		for(new i = 0; i < sizeof(szWeaponName); i++) {
			if(containi(args, szWeaponName[i]) != -1) {
				engclient_cmd(id, szWeaponName[i]);
				return PLUGIN_HANDLED;
			}
		}
	}
	return PLUGIN_CONTINUE;
}

@CBasePlayer_AddPlayerItem_Post(const pPlayer, const pItem) {
	new szClassname[32];
	get_entvar(pItem, var_classname, szClassname, charsmax(szClassname));

	message_begin(MSG_ONE, WeaponList, .player = pPlayer); {
		write_string(fmt("weapon/%s", szClassname));
		write_byte(get_member(pItem, m_Weapon_iPrimaryAmmoType));
		write_byte(rg_get_iteminfo(pItem, ItemInfo_iMaxAmmo1));
		write_byte(-1);
		write_byte(-1);
		write_byte(rg_get_iteminfo(pItem, ItemInfo_iSlot));
		write_byte(rg_get_iteminfo(pItem, ItemInfo_iPosition));
		write_byte(rg_get_iteminfo(pItem, ItemInfo_iId));
		write_byte(rg_get_iteminfo(pItem, ItemInfo_iFlags));
	}
	message_end();
}